#!/bin/bash


COMP="$1"

RET_MODE="$2"

DB_PATH="/opt/apps/com.plustek.linuxaction/files/webfxscand/get_device_id_list.db"

OS_NAME=`lsb_release -i| awk '{print $3}'`
if [ "${OS_NAME^^}" != "KYLIN" ]; then
#	echo NOT Kylin!!!
	OS_NAME="UOS"
fi




get_device_by_vid(){
	VID="$1"
	#echo "VID=$VID"
	lsusb | grep $VID |
	while read SCANNER
	do
		#echo -e SCANNER=${SCANNER}


		BUS_ID=`echo ${SCANNER} | awk '{print $2}'`
		#echo BUS_ID=${BUS_ID}

		DEVICE_ID=`echo ${SCANNER} | awk '{print $4}' | cut -d : -f1`
		#echo DEVICE_ID=${DEVICE_ID}

		PID=`echo ${SCANNER} | awk '{print $6}' | cut -d : -f2`
		#echo PID=${PID}


		if [ ${PID} ]; then

			if [ "${OS_NAME^^}" = "UOS" ]; then
				FILENAME=`grep -i "0x${PID}" /usr/local/etc/sane.d/pl*  -wl`
				if [ "${DB_PATH}" = "" ]; then
					DB_PATH="/opt/apps/com.plustek.linuxaction/files/webfxscand/get_device_id_list.db"
				fi
			else
				FILENAME=`grep -i "0x${PID}" /etc/sane.d/pl*  -wl`
				if [ "${DB_PATH}" = "" ]; then
 					DB_PATH="/opt/apps/scanner-driver-plustek-common/webfxscand/get_device_id_list.db"
				fi
			fi
			#echo FILENAME=${FILENAME}

			MODEL_NAME=`basename ${FILENAME} | cut -d . -f1`
			#echo MODEL_NAME=${MODEL_NAME}

			SCANNER_ID="${MODEL_NAME}:libusb:${BUS_ID}:${DEVICE_ID}"
			#echo ${SCANNER_ID}


			SCANNER_NAME=`grep -i "${PID}" "${DB_PATH}" | cut -d , -f 2`
			#echo SCANNER_NAME=${SCANNER_NAME}

			#RET="device  \`${SCANNER_ID}' is a $COMP $SCANNER_NAME scanner"
			if [ "${RET_MODE}" == "fullname" ]; then
				RET="${SCANNER_ID}"
			elif [ "${RET_MODE}" == "fast" ]; then
				RET="device:${SCANNER_ID}@$COMP $SCANNER_NAME scanner,"
			else
				RET="$COMP $SCANNER_NAME scanner,"
			fi
		else

			#RET="\nNo scanners were identified. If you were expecting something different,\ncheck that the scanner is plugged in, turned on and detected by the\nsane-find-scanner tool (if appropriate). Please read the documentation\nwhich came with this software (README, FAQ, manpages)."
			RET=""

		fi

		echo -e ${RET}

	done

}

get_device_by_vid 07b3 

